/* $Id: symbol.h,v 1.1 1996/10/24 04:27:50 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	V{l[ǗW[wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#ifndef	SYMBOL_H
#define	SYMBOL_H

#ifdef	STATIC_SYM_BUF
#undef	STATIC_SYM_BUF
#endif

#ifdef	STATIC_CONST_SYM_BUF
#undef	STATIC_CONST_SYM_BUF
#endif


/* symlist ͓Ԗڈȍ~̃V{ƁA symlist ւ̃|C^ */
typedef struct _symlist {
    struct _symlist* next;
    char* sym;
} symlist;

/* symbol ͍ŏ̃V{ƁAsymlist ւ̃|C^ */
typedef struct {
    address adrs;
    UWORD   type;
    symlist* next;
    char* sym;
} symbol;

#ifdef	STATIC_CONST_SYM_BUF
typedef struct {
    address adrs;
    char    *sym;
} const_symbol;
#endif


#define	XDEF_COMMON	0x0003
#define	XDEF_ABS	0x0200
#define	XDEF_TEXT	0x0201
#define	XDEF_DATA	0x0202
#define	XDEF_BSS	0x0203
#define	XDEF_STACK	0x0204


extern void	init_symtable (void);
#ifndef	OSKDIS
extern void	make_symtable (void);
extern int	output_symbol_table (const char*, const char*, const char*);
#endif
extern void	free_symbuf (void);
extern symbol*	symbol_search (address);
extern void	add_symbol (address, int, char*);
extern boolean	is_exist_symbol (void);

#if 0
extern void	del_symbol( address );
#endif
#ifdef	STATIC_CONST_SYM_BUF
extern void	add_constsymbol (address, char*);
extern int	get_constsymbol_num (void);
extern const_symbol* get_constsymbol (int);
#endif

#endif	/* SYMBOL_H */

/* EOF */
