/* $Id: table.h,v 1.1 1996/10/24 04:27:50 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	e[uW[wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#ifndef	TABLE_H
#define	TABLE_H

#ifdef	STATIC_TABLE_BUF
#undef	STATIC_TABLE_BUF
#endif


#ifdef	STATIC_TABLE_BUF
#define MAX_TABLE_NUM	 256
#define MAX_TABLE_LINE	 32
#define EXPR_MAX_LENGTH	 100
#endif


/* p ɂ Ofst 𑫂ĂȂln */
#define PEEK_BYTE(p) ((UBYTE)(BeginBSS <= (p) ? 0 : *(p + Ofst)))
#define PEEK_WORD(p) ((UWORD)(BeginBSS <= (p) ? 0 : ((p + Ofst)[0] << 8) + (p + Ofst)[1]))
#define PEEK_LONG(p) ((ULONG)(BeginBSS <= (p) ? 0 : ((int)(p) & 1) ? \
		(*(ULONG*)(p + Ofst - 1) << 8) + (p + Ofst)[3] : *(ULONG*)(p + Ofst)))


/*
  e[u̍\
  PAhXɂP table 
  table.formulaptr[ 0 ... table.lines - 1 ] e[ũoێĂ
*/

typedef struct {
#if 0
    int     count;	/* now, count is evaluated each time */
#endif
    opesize id;
    boolean hidden;
    int     line;
#ifdef	STATIC_TABLE_BUF
    char    expr[EXPR_MAX_LENGTH];
#else
    char*   expr;
#endif
} formula;

typedef struct {
    address tabletop;
    int     loop;
    int     lines;
    formula *formulaptr;	/* formula ̔zւ̃|C^ */
} table;

extern void	read_tablefile( char* );
extern table	*search_table( address );

typedef enum {
    PARSE_ANALYZING ,
    PARSE_GENERATING ,
} parse_mode;


extern char	  *Lexptr;
extern parse_mode ParseMode;
extern int	  Eval_Value;
extern address	  Eval_TableTop;
extern address	  Eval_PC;
extern int	  Eval_Bytes;
extern opesize	  Eval_ID;
extern int	  Eval_Count;
extern int	  Eval_Break;
extern opesize	  Eval_SizeID;
extern char	  Eval_ResultString[ 256 ];


#endif	/* TABLE_H */

/* EOF */
